//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup Tool "FUNSSEL" developed for the 
// Simulator League of the RoboCup 2001 competition
//
// Copyright (C) 1998, 1999, 2000, 2001 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program is published under the terms of the GNU General Public 
// License as published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

#ifndef FUNSSELIO_H
#define FUNSSELIO_H
#include "SoccerMessage.h"
#include "Socket.h"
#include <string.h>

class FunsselIO {
  int curtime;
  int srvtime;
  SoccerMessage smsg;

  Socket sock;
public:
  FunsselIO(int port, const char *host);

  enum Result {
    NoMsg         = 0,
    MsgReady      = 1,
    MsgEol        = 2,
    ServerStarted = 3,
    MsgDropped    = 4,
    NewSrvTime    = 5,
    NewDataburst  = 6,
  };

  void fetch(int);
  void fetchRel(int);
  void syncPlay();
  void maxRunTime(int);
  void filterOn();
  void filterOff();
  void startServer();
  void stopServer();
  void quit();
  void init();
  void sendMsg(const std::string &);
  void sendMsg(const SoccerMessage &m) { sendMsg(std::string(m)); };

  Result getNextMsg();

  int currentTime() const { return curtime; }
  int serverTime()  const { return srvtime; }
  const SoccerMessage &currentMsg() const { return smsg; }
};

#endif
