//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2003 competition
//
// Copyright (C) 1998, 1999, 2000, 2001, 2002, 2003 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program is published under the terms of the GNU General Public
// License as published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

#ifndef _MINMAX_H
#define _MINMAX_H

#ifndef LINUX

inline int min(int x, int y)
{
  return x<y ? x : y;
}

inline int min(int x, long y)
{
  return x<y ? x : y;
}

inline int min(long x, int y)
{
  return x<y ? x : y;
}

inline long min(long x, long y)
{
  return x<y ? x : y;
}

inline double min(double x, double y)
{
  return x<y ? x : y;
}


inline int max(int x, int y)
{
  return y<x ? x : y;
}

inline int max(int x, long y)
{
  return y<x ? x : y;
}

inline int max(long x, int y)
{
  return y<x ? x : y;
}

inline long max(long x, long y)
{
  return y<x ? x : y;
}

inline double max(double x, double y)
{
  return y<x ? x : y;
}

inline double sqr(double x)
{
  return x*x;
}

#endif

// a^n with n a natural number
static inline double
power( double a, int n )
{
  double b = 1;
  while (n > 0) {
    if (n & 1)
      b *= a;
    n /= 2;
    a *= a;
  }
  return b;
}

#endif
